# NOTE: Derived from blib/lib/WWW/Fido.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package WWW::Fido;

#line 202 "blib/lib/WWW/Fido.pm (autosplit into blib/lib/auto/WWW/Fido/send.al)"
sub send() {
	my $self = shift;
	my $message = shift;
	my $error = undef;
	my $maxlength = 155;
	my %data;
	my %data2;
	my $useragent;
	my $request;
        my $cookiejar;
	my $result;
	my $areacode;
	my $phone;

	if (!$self->{_phone}) {
		$error = "No phone number associated with object yet";
		}
	elsif (length($message) < 1) {
		$error = "Message is too short";
		}
	elsif (length($message) > $maxlength) {
		$error = "Message is too long (max is $maxlength)";
		}
	if ($error) {
		$@ = $error;
		return 0;
		}

	#
	# Let's define some variables we'll need while submitting
	#

	($areacode, $phone) = ($self->{_phone} =~ /^(\d\d\d)(\d\d\d\d\d\d\d)$/);

	%data = (
		'lang'			=>	'en',
		'mailfrom'		=>	'fidoweb@infinetcomm.com',
		'mailsubject'	=>	'SMS for you!',
		'areacode'		=>	$areacode,
		'number'			=>	$phone,
		'yourname'		=>	$self->{_name},
		'message'		=>	$message,
		'count'			=>	length($message),
		);

	%data2 = (
		'phone'		=>	$self->{_phone},
		'name'		=>	$self->{_name},
		'text'		=>	$message,
		'textEnc'	=>	$message,
		'lang'		=>	'en',
		'yourName'	=>	$self->{_name},
		);

	#
	# Let's construct the useragent we'll use for our upcoming requests
	#
	$cookiejar = HTTP::Cookies->new;
	$useragent = LWP::UserAgent->new(
		'agent'			=>	"WWW::Fido/$VERSION",
		'cookie_jar'		=>	$cookiejar,
		'requests_redirectable'	=>	['GET', 'POST', 'HEAD'],
		);

	#
	# We need to get the cookies and login stuff by visiting the first page
	#
	$result = $useragent->get("http://www.fido.ca/portal/home/quickMsg.jsp?lang=en");
	$result = $result->as_string();
	if ($result !~ /You can send a message of up to/i) {
		$@ = "Did not receive initial entry page";
		return 0;
		}
	#
	# We submit to the first page:
	#
	$result = $useragent->post("http://www.fido.ca/portal/home/quickValidate.jsp", \%data);
	$result = $result->as_string();
	if ($result !~ /Please confirm the following/i) {
		$@ = "Did not receive the confirmation page";
		return 0;
		}
	#
	# Now we submit to the second page
	#
	$result = $useragent->post("http://www.fido.ca/portal/home/sendmessage.jsp", \%data2);
	$result = $result->as_string();
	if ($result !~ /has been accepted/) {
		$@ = "Did not receive final success page";
		return 0;
		}

	return 1;

	}
1;
# end of WWW::Fido::send
